#define _XOPEN_SOURCE 600
#define _DEFAULT_SOURCE

#include <stdlib.h>
#include <unistd.h>
#include <signal.h>
#include <fcntl.h>
//#include <sys/ioctl.h>
//#include <sys/types.h>
#include <pwd.h>
#include <termios.h>

void panic(char *fmt, ...);

void
sigchld(int s)
{
	exit(0);
}

void
shell(void)
{
	struct passwd *pw;

	setenv("TERM", "dumb", 1);

	pw = getpwuid(getuid());
	if(pw == NULL)
		panic("no user");
	execl(pw->pw_shell, pw->pw_shell, NULL);
	exit(1);
}

int
lcase(int fd)
{
	struct termios tio;
	if(tcgetattr(fd, &tio) < 0) return -1;
	tio.c_oflag |= OLCUC;
	tio.c_iflag |= IUCLC;
	if(tcsetattr(fd, TCSAFLUSH, &tio) < 0) return -1;
	return 0;
}

int
makepty(void)
{
	int pty;
	char *name;

	pty = posix_openpt(O_RDWR);
	if(pty < 0 ||
	   grantpt(pty) < 0 ||
	   unlockpt(pty) < 0)
		panic("couldn't get pty");

	name = ptsname(pty);
	printf("%s\n", name);

	switch(fork()){
	case -1:
		panic("fork failed");

	case 0:
		close(pty);
		close(0);
		close(1);
		close(2);

		setsid();

		if(open(name, O_RDWR) != 0)
			exit(1);
		lcase(0);

		dup(0);
		dup(1);

		shell();

	default:
		signal(SIGCHLD, sigchld);
	}

	return pty;
}
